C
C
      PROGRAM EVOLUTION
C
C
C     ... D.Gaude-Fugarolas ...
C      Cambridge March 2002
C
C
C     ...prepares data on phase evolution and 
C        stores the data in 'evolphse.dat'  .... 
C
      IMPLICIT NONE
C
      INTEGER IN3, IN4, IN5, IN6, OUT2
      INTEGER I, J
C
      DOUBLE PRECISION  EVOLT(8), TARRAY(10)
      DOUBLE PRECISION  RATE, OTHER1, OTHER2, TMS 
C
      PARAMETER(IN3 = 10)
      PARAMETER(IN4 = 11)
      PARAMETER(IN5 = 12)
      PARAMETER(IN6 = 13)
      PARAMETER(OUT2 = 15)
C
C
C     ...opens files with results from calculations...
C
C
      OPEN(UNIT=IN3,FILE="evol1.tmp")
C
      OPEN(UNIT=IN4,FILE="evol2.tmp")
C
      OPEN(UNIT=IN5,FILE="hermes.dat")
C
      OPEN(UNIT=IN6,FILE="outbain3.dat")
C
      OPEN(UNIT=OUT2,FILE="evolphse.dat")
C
C
C
      WRITE(OUT2,101)
C
      READ(IN3, *) (TARRAY(I), I=1, 7)
C
 11   IF (TARRAY(1).LT.0.0) THEN
C
         OTHER2 = EVOLT(1)
C
         OTHER1 = 1.0 - EVOLT(5)
C
         GOTO 599   
C
      ENDIF
C
C    ...  total ferrite  ...
C
      TARRAY(8) = TARRAY(3) + TARRAY(4)
C
C    ...  austenite   ...
C
      TARRAY(9) = 1.0 - (TARRAY(5) + TARRAY(8))
C
C
C   ... Modification to avoid over 100% transformation
C
C
      IF(TARRAY(9).LT.0.0) THEN
         TARRAY(5) = TARRAY(5) + TARRAY(9)
         TARRAY(9) = 0.0
      ENDIF
C
C
      DO 10 I=1, 5
C
         EVOLT(I) = TARRAY(I)
C
  10  CONTINUE
C
      EVOLT(3) = TARRAY(9)
C
      EVOLT(4) = TARRAY(8)
C
      DO 20 I=6, 8
C
         EVOLT(I) =0.0
C
  20  CONTINUE
C
      DO 30 I=3, 7
C
         EVOLT(8) = EVOLT(8) + EVOLT(I)
C
  30  CONTINUE
C
C
C   ...write phase evolution in file...
C
      WRITE(OUT2,103) (EVOLT(J),J=1,8)
C
C
      READ(IN3, *) (TARRAY(I), I=1, 7)
C
      GOTO 11
C
C***
C
 599  CONTINUE
C
C   ...Start with the bainite and martensite 
C       'stage' of the transformation
C
C
      DO 40 I=1, 10
C
         READ(IN5,*)
C
  40  CONTINUE 
C
      READ(IN5,*) TMS
C
      READ(IN5,*)
      READ(IN5,*)
      READ(IN5,*) RATE
C
  21  READ(IN4, *) (TARRAY(J), J=1,4)
C
      IF(TARRAY(2).GT.1.0) THEN
C
         EVOLT(1) = ((EVOLT(2)-TARRAY(3))/RATE) + EVOLT(1)
C
         EVOLT(6) = TARRAY(1)*EVOLT(4)*OTHER1
C
         EVOLT(3) = 1.0-(EVOLT(4)+ EVOLT(5)+EVOLT(6)+EVOLT(7))        
C
         EVOLT(8) = 0.0
C
         DO 50 J=3, 7
C
            EVOLT(8) = EVOLT(8) + EVOLT(J)
C
  50     CONTINUE
C
C
         OTHER2 = EVOLT(1)
C
         EVOLT(2) = TARRAY(3)
C
         WRITE(OUT2,103) (EVOLT(J),J=1,8)
C
      GOTO 21
C
C
      ELSE IF(TARRAY(2).LT.1.0) THEN
C
C
         EVOLT(1) = 0.99*((EVOLT(2)-TARRAY(3))/RATE) + EVOLT(1)
C
         EVOLT(2) = 1.01*TARRAY(3)
C
         READ(IN6, *) (TARRAY(J), J=1,4)
C
         EVOLT(6) = OTHER1*TARRAY(2)
         EVOLT(3) = 1.0 - (EVOLT(4) + EVOLT(5) + EVOLT(6) + EVOLT(7))
         EVOLT(8) = EVOLT(4) + EVOLT(5) + EVOLT(6) + EVOLT(7) + EVOLT(3)
C
         WRITE(OUT2,103) (EVOLT(J),J=1,8) 
C
         EVOLT(1) = 1.01*EVOLT(1)
C
         EVOLT(2) = 0.99*EVOLT(2)
C
         EVOLT(7) = OTHER1*TARRAY(3)
         EVOLT(3) = OTHER1*TARRAY(4)
         EVOLT(8) = EVOLT(4) + EVOLT(5) + EVOLT(6) + EVOLT(7) + EVOLT(3)
C

C
         WRITE(OUT2,103) (EVOLT(J),J=1,8)
C
C
      ENDIF
C
C
      EVOLT(1)= ((EVOLT(2)-25.0)/RATE) + EVOLT(1)
C
      EVOLT(2) = 25.0
C
      WRITE(OUT2,103) (EVOLT(J),J=1,8)
C
C
      CLOSE(IN3)
C
      CLOSE(IN4)
C
      CLOSE(IN5)
C
      CLOSE(IN6)
C
      CLOSE(OUT2)
C
C
      STOP
C
C
  101 FORMAT(4x,'Time /s', 1x, 'Temperature /C', 4x, 'Vaus',4x,'Vferr',
     $     3x,'Vpearl',2x, 'Vbain',3x, 'Vmart', 3x, 'Vtot')
C
  103 FORMAT(F9.2,4X,F7.1,8X,F7.4,1X,F7.4,1X,
     $ 	     F7.4,1X,F7.4,1X,F7.4,1X,F7.4)
C
C
C
      END
C
